#include "tencent.h"


bool UserProfile::LoadDataHelper(ifstream& inFile, sqlite3* db)
{
	const char* sqlStr1 = "insert into user_profile(UserId, Year_of_birth, Gender, Number_of_tweet)values(?1, ?2, ?3, ?4);";
	const char* sqlStr2 = "insert into user_profile_detail(UserId, Tag_Id)values(?1, ?2);";
	sqlite3_stmt* pProfileStmt, * pDetailStmt;
	int rc = 0;
	if ((rc = sqlite3_prepare_v2(db, sqlStr1, strlen(sqlStr1) + 1, &pProfileStmt, NULL)) == 0
		&& (rc = sqlite3_prepare_v2(db, sqlStr2, strlen(sqlStr2) + 1, &pDetailStmt, NULL)) == 0)
	{
		while (!inFile.eof())
		{
			int UserId, Year_of_birth, Gender, Number_of_tweet;
			string Tag_Ids;
			inFile >> UserId >> Year_of_birth >> Gender >> Number_of_tweet >> Tag_Ids;
			rc = 0;
			rc += sqlite3_bind_int(pProfileStmt, 1, UserId);
			rc += sqlite3_bind_int(pProfileStmt, 2, Year_of_birth);
			rc += sqlite3_bind_int(pProfileStmt, 3, Gender);
			rc += sqlite3_bind_int(pProfileStmt, 4, Number_of_tweet);
			if (rc == 0)
			{
				do
				{
					rc = sqlite3_step(pProfileStmt);
				}
				while (rc == SQLITE_BUSY);
				if (rc != SQLITE_OK && rc != SQLITE_DONE)
				{
					cout << "sqlite3_step error of " << rc << " of msg " << sqlite3_errmsg(db) << endl;
					break;
				}
				else
				{
					rc = 0;
				}
			}
			else
			{
				cout << "sqlite3_bind error of " << rc << " of msg " << sqlite3_errmsg(db) << endl;
				break;
			}
			rc += sqlite3_clear_bindings(pProfileStmt);
			rc += sqlite3_reset(pProfileStmt);
			if (rc == 0)
			{
				size_t start = 0;
				size_t pos = 0;
				do
				{
					pos = Tag_Ids.find_first_of(';', start);
					string sub = Tag_Ids.substr(start, pos - start);
					start = pos + 1;
					int id;
					sscanf(sub.c_str(), "%d", &id);
					rc += sqlite3_bind_int(pDetailStmt, 1, UserId);
					rc += sqlite3_bind_int(pDetailStmt, 2, id);
					if (rc != 0)
					{
						cout << "sqlite3_bind_int error of " << rc << " of msg " << sqlite3_errmsg(db) << endl;
						break;
					}
					do
					{
						rc = sqlite3_step(pDetailStmt);
					}
					while (rc == SQLITE_BUSY);
					if (rc != SQLITE_OK && rc != SQLITE_DONE)
					{
						cout << "sqlite3_step error of " << rc << " of msg " << sqlite3_errmsg(db) << endl;
						break;
					}
					else
					{
						rc = 0;
					}
					rc += sqlite3_clear_bindings(pDetailStmt);
					rc += sqlite3_reset(pDetailStmt);
				}
				while (pos != string::npos);

			}
			else
			{
				cout << "sqlite3_reset error of " << rc << " of msg " << sqlite3_errmsg(db) << endl;
				break;
			}

		}
		sqlite3_finalize(pProfileStmt);
		sqlite3_finalize(pDetailStmt);
	}
	else
	{
		cout << "sqlite3_prepare_v2 error of " << rc << " of msg " << sqlite3_errmsg(db) << endl;
	}
	return rc == 0;
}
